org.apache.lucene.search

## Class DocIdSetIterator

- java.lang.Object
- - org.apache.lucene.search.DocIdSetIterator

- Direct Known Subclasses:
    BinaryDocValues, BitSetIterator, ConjunctionDISI, DisjunctionDISIApproximation, FilteredDocIdSetIterator, NumericDocValues, PostingsEnum, SortedNumericDocValues, SortedSetDocValues, Spans

      public abstract class DocIdSetIterator
      extends Object

  This abstract class defines methods to iterate over a set of non-decreasing doc ids. Note that this class assumes it iterates on doc Ids, and therefore `NO_MORE_DOCS` is set to 2147483647 in order to be used as a sentinel object. Implementations of this class are expected to consider `Integer.MAX_VALUE` as an invalid value.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `NO_MORE_DOCS` When returned by `nextDoc()`, `advance(int)` and `docID()` it means there are no more docs in the iterator.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DocIdSetIterator()`

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `abstract int` | `advance(int target)` Advances to the first beyond the current whose document number is greater than or equal to target, and returns the document number itself.
    `static DocIdSetIterator` | `all(int maxDoc)` A `DocIdSetIterator` that matches all documents up to `maxDoc - 1`.
    `abstract long` | `cost()` Returns the estimated cost of this `DocIdSetIterator`.
    `abstract int` | `docID()` Returns the following: `-1` if `nextDoc()` or `advance(int)` were not called yet.
    `static DocIdSetIterator` | `empty()` An empty `DocIdSetIterator` instance
    `abstract int` | `nextDoc()` Advances to the next document in the set and returns the doc it is currently on, or `NO_MORE_DOCS` if there are no more docs in the set. NOTE: after the iterator has exhausted you should not call this method, as it may result in unpredicted behavior.
    `protected int` | `slowAdvance(int target)` Slow (linear) implementation of `advance(int)` relying on `nextDoc()` to advance beyond the target position.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### NO_MORE_DOCS

          public static final int NO_MORE_DOCS

      When returned by `nextDoc()`, `advance(int)` and `docID()` it means there are no more docs in the iterator.
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### DocIdSetIterator

          public DocIdSetIterator()

  - ### Method Detail

    - #### empty

          public static final DocIdSetIterator empty()

      An empty `DocIdSetIterator` instance

    - #### all

          public static final DocIdSetIterator all(int maxDoc)

      A `DocIdSetIterator` that matches all documents up to `maxDoc - 1`.

    - #### docID

          public abstract int docID()

      Returns the following:
      - `-1` if `nextDoc()` or `advance(int)` were not called yet.
      - `NO_MORE_DOCS` if the iterator has exhausted.
      - Otherwise it should return the doc ID it is currently on.

      Since:
        2.9

    - #### nextDoc

          public abstract int nextDoc()
                               throws IOException

      Advances to the next document in the set and returns the doc it is currently on, or `NO_MORE_DOCS` if there are no more docs in the set.
      NOTE: after the iterator has exhausted you should not call this method, as it may result in unpredicted behavior.
      Throws:
        `IOException`
      Since:
        2.9

    - #### advance

          public abstract int advance(int target)
                               throws IOException

      Advances to the first beyond the current whose document number is greater than or equal to target, and returns the document number itself. Exhausts the iterator and returns `NO_MORE_DOCS` if target is greater than the highest document number in the set.

      The behavior of this method is undefined when called with `target ≤ current`, or after the iterator has exhausted. Both cases may result in unpredicted behavior.

      When `target > current` it behaves as if written:

           int advance(int target) {
             int doc;
             while ((doc = nextDoc()) < target) {
             }
             return doc;
           }

      Some implementations are considerably more efficient than that.

      NOTE: this method may be called with `NO_MORE_DOCS` for efficiency by some Scorers. If your implementation cannot efficiently determine that it should exhaust, it is recommended that you check for that value in each call to this method.

      Throws:
        `IOException`
      Since:
        2.9

    - #### slowAdvance

          protected final int slowAdvance(int target)
                                   throws IOException

      Slow (linear) implementation of `advance(int)` relying on `nextDoc()` to advance beyond the target position.
      Throws:
        `IOException`

    - #### cost

          public abstract long cost()

      Returns the estimated cost of this `DocIdSetIterator`.

      This is generally an upper bound of the number of documents this iterator might match, but may be a rough heuristic, hardcoded value, or otherwise completely inaccurate.

Copyright © 2000-2018 Apache Software Foundation. All Rights Reserved.